import { BatchDeleteBuildsCommandInput, BatchDeleteBuildsCommandOutput } from "../commands/BatchDeleteBuildsCommand";
import { BatchGetBuildBatchesCommandInput, BatchGetBuildBatchesCommandOutput } from "../commands/BatchGetBuildBatchesCommand";
import { BatchGetBuildsCommandInput, BatchGetBuildsCommandOutput } from "../commands/BatchGetBuildsCommand";
import { BatchGetProjectsCommandInput, BatchGetProjectsCommandOutput } from "../commands/BatchGetProjectsCommand";
import { BatchGetReportGroupsCommandInput, BatchGetReportGroupsCommandOutput } from "../commands/BatchGetReportGroupsCommand";
import { BatchGetReportsCommandInput, BatchGetReportsCommandOutput } from "../commands/BatchGetReportsCommand";
import { CreateProjectCommandInput, CreateProjectCommandOutput } from "../commands/CreateProjectCommand";
import { CreateReportGroupCommandInput, CreateReportGroupCommandOutput } from "../commands/CreateReportGroupCommand";
import { CreateWebhookCommandInput, CreateWebhookCommandOutput } from "../commands/CreateWebhookCommand";
import { DeleteBuildBatchCommandInput, DeleteBuildBatchCommandOutput } from "../commands/DeleteBuildBatchCommand";
import { DeleteProjectCommandInput, DeleteProjectCommandOutput } from "../commands/DeleteProjectCommand";
import { DeleteReportCommandInput, DeleteReportCommandOutput } from "../commands/DeleteReportCommand";
import { DeleteReportGroupCommandInput, DeleteReportGroupCommandOutput } from "../commands/DeleteReportGroupCommand";
import { DeleteResourcePolicyCommandInput, DeleteResourcePolicyCommandOutput } from "../commands/DeleteResourcePolicyCommand";
import { DeleteSourceCredentialsCommandInput, DeleteSourceCredentialsCommandOutput } from "../commands/DeleteSourceCredentialsCommand";
import { DeleteWebhookCommandInput, DeleteWebhookCommandOutput } from "../commands/DeleteWebhookCommand";
import { DescribeCodeCoveragesCommandInput, DescribeCodeCoveragesCommandOutput } from "../commands/DescribeCodeCoveragesCommand";
import { DescribeTestCasesCommandInput, DescribeTestCasesCommandOutput } from "../commands/DescribeTestCasesCommand";
import { GetReportGroupTrendCommandInput, GetReportGroupTrendCommandOutput } from "../commands/GetReportGroupTrendCommand";
import { GetResourcePolicyCommandInput, GetResourcePolicyCommandOutput } from "../commands/GetResourcePolicyCommand";
import { ImportSourceCredentialsCommandInput, ImportSourceCredentialsCommandOutput } from "../commands/ImportSourceCredentialsCommand";
import { InvalidateProjectCacheCommandInput, InvalidateProjectCacheCommandOutput } from "../commands/InvalidateProjectCacheCommand";
import { ListBuildBatchesCommandInput, ListBuildBatchesCommandOutput } from "../commands/ListBuildBatchesCommand";
import { ListBuildBatchesForProjectCommandInput, ListBuildBatchesForProjectCommandOutput } from "../commands/ListBuildBatchesForProjectCommand";
import { ListBuildsCommandInput, ListBuildsCommandOutput } from "../commands/ListBuildsCommand";
import { ListBuildsForProjectCommandInput, ListBuildsForProjectCommandOutput } from "../commands/ListBuildsForProjectCommand";
import { ListCuratedEnvironmentImagesCommandInput, ListCuratedEnvironmentImagesCommandOutput } from "../commands/ListCuratedEnvironmentImagesCommand";
import { ListProjectsCommandInput, ListProjectsCommandOutput } from "../commands/ListProjectsCommand";
import { ListReportGroupsCommandInput, ListReportGroupsCommandOutput } from "../commands/ListReportGroupsCommand";
import { ListReportsCommandInput, ListReportsCommandOutput } from "../commands/ListReportsCommand";
import { ListReportsForReportGroupCommandInput, ListReportsForReportGroupCommandOutput } from "../commands/ListReportsForReportGroupCommand";
import { ListSharedProjectsCommandInput, ListSharedProjectsCommandOutput } from "../commands/ListSharedProjectsCommand";
import { ListSharedReportGroupsCommandInput, ListSharedReportGroupsCommandOutput } from "../commands/ListSharedReportGroupsCommand";
import { ListSourceCredentialsCommandInput, ListSourceCredentialsCommandOutput } from "../commands/ListSourceCredentialsCommand";
import { PutResourcePolicyCommandInput, PutResourcePolicyCommandOutput } from "../commands/PutResourcePolicyCommand";
import { RetryBuildBatchCommandInput, RetryBuildBatchCommandOutput } from "../commands/RetryBuildBatchCommand";
import { RetryBuildCommandInput, RetryBuildCommandOutput } from "../commands/RetryBuildCommand";
import { StartBuildBatchCommandInput, StartBuildBatchCommandOutput } from "../commands/StartBuildBatchCommand";
import { StartBuildCommandInput, StartBuildCommandOutput } from "../commands/StartBuildCommand";
import { StopBuildBatchCommandInput, StopBuildBatchCommandOutput } from "../commands/StopBuildBatchCommand";
import { StopBuildCommandInput, StopBuildCommandOutput } from "../commands/StopBuildCommand";
import { UpdateProjectCommandInput, UpdateProjectCommandOutput } from "../commands/UpdateProjectCommand";
import { UpdateProjectVisibilityCommandInput, UpdateProjectVisibilityCommandOutput } from "../commands/UpdateProjectVisibilityCommand";
import { UpdateReportGroupCommandInput, UpdateReportGroupCommandOutput } from "../commands/UpdateReportGroupCommand";
import { UpdateWebhookCommandInput, UpdateWebhookCommandOutput } from "../commands/UpdateWebhookCommand";
import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@aws-sdk/protocol-http";
import { SerdeContext as __SerdeContext } from "@aws-sdk/types";
export declare const serializeAws_json1_1BatchDeleteBuildsCommand: (input: BatchDeleteBuildsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1BatchGetBuildBatchesCommand: (input: BatchGetBuildBatchesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1BatchGetBuildsCommand: (input: BatchGetBuildsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1BatchGetProjectsCommand: (input: BatchGetProjectsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1BatchGetReportGroupsCommand: (input: BatchGetReportGroupsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1BatchGetReportsCommand: (input: BatchGetReportsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1CreateProjectCommand: (input: CreateProjectCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1CreateReportGroupCommand: (input: CreateReportGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1CreateWebhookCommand: (input: CreateWebhookCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DeleteBuildBatchCommand: (input: DeleteBuildBatchCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DeleteProjectCommand: (input: DeleteProjectCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DeleteReportCommand: (input: DeleteReportCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DeleteReportGroupCommand: (input: DeleteReportGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DeleteResourcePolicyCommand: (input: DeleteResourcePolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DeleteSourceCredentialsCommand: (input: DeleteSourceCredentialsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DeleteWebhookCommand: (input: DeleteWebhookCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DescribeCodeCoveragesCommand: (input: DescribeCodeCoveragesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1DescribeTestCasesCommand: (input: DescribeTestCasesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1GetReportGroupTrendCommand: (input: GetReportGroupTrendCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1GetResourcePolicyCommand: (input: GetResourcePolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ImportSourceCredentialsCommand: (input: ImportSourceCredentialsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1InvalidateProjectCacheCommand: (input: InvalidateProjectCacheCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListBuildBatchesCommand: (input: ListBuildBatchesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListBuildBatchesForProjectCommand: (input: ListBuildBatchesForProjectCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListBuildsCommand: (input: ListBuildsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListBuildsForProjectCommand: (input: ListBuildsForProjectCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListCuratedEnvironmentImagesCommand: (input: ListCuratedEnvironmentImagesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListProjectsCommand: (input: ListProjectsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListReportGroupsCommand: (input: ListReportGroupsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListReportsCommand: (input: ListReportsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListReportsForReportGroupCommand: (input: ListReportsForReportGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListSharedProjectsCommand: (input: ListSharedProjectsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListSharedReportGroupsCommand: (input: ListSharedReportGroupsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1ListSourceCredentialsCommand: (input: ListSourceCredentialsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1PutResourcePolicyCommand: (input: PutResourcePolicyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1RetryBuildCommand: (input: RetryBuildCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1RetryBuildBatchCommand: (input: RetryBuildBatchCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1StartBuildCommand: (input: StartBuildCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1StartBuildBatchCommand: (input: StartBuildBatchCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1StopBuildCommand: (input: StopBuildCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1StopBuildBatchCommand: (input: StopBuildBatchCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1UpdateProjectCommand: (input: UpdateProjectCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1UpdateProjectVisibilityCommand: (input: UpdateProjectVisibilityCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1UpdateReportGroupCommand: (input: UpdateReportGroupCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_json1_1UpdateWebhookCommand: (input: UpdateWebhookCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const deserializeAws_json1_1BatchDeleteBuildsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchDeleteBuildsCommandOutput>;
export declare const deserializeAws_json1_1BatchGetBuildBatchesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetBuildBatchesCommandOutput>;
export declare const deserializeAws_json1_1BatchGetBuildsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetBuildsCommandOutput>;
export declare const deserializeAws_json1_1BatchGetProjectsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetProjectsCommandOutput>;
export declare const deserializeAws_json1_1BatchGetReportGroupsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetReportGroupsCommandOutput>;
export declare const deserializeAws_json1_1BatchGetReportsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<BatchGetReportsCommandOutput>;
export declare const deserializeAws_json1_1CreateProjectCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateProjectCommandOutput>;
export declare const deserializeAws_json1_1CreateReportGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateReportGroupCommandOutput>;
export declare const deserializeAws_json1_1CreateWebhookCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateWebhookCommandOutput>;
export declare const deserializeAws_json1_1DeleteBuildBatchCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteBuildBatchCommandOutput>;
export declare const deserializeAws_json1_1DeleteProjectCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteProjectCommandOutput>;
export declare const deserializeAws_json1_1DeleteReportCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteReportCommandOutput>;
export declare const deserializeAws_json1_1DeleteReportGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteReportGroupCommandOutput>;
export declare const deserializeAws_json1_1DeleteResourcePolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteResourcePolicyCommandOutput>;
export declare const deserializeAws_json1_1DeleteSourceCredentialsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteSourceCredentialsCommandOutput>;
export declare const deserializeAws_json1_1DeleteWebhookCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteWebhookCommandOutput>;
export declare const deserializeAws_json1_1DescribeCodeCoveragesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeCodeCoveragesCommandOutput>;
export declare const deserializeAws_json1_1DescribeTestCasesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeTestCasesCommandOutput>;
export declare const deserializeAws_json1_1GetReportGroupTrendCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetReportGroupTrendCommandOutput>;
export declare const deserializeAws_json1_1GetResourcePolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetResourcePolicyCommandOutput>;
export declare const deserializeAws_json1_1ImportSourceCredentialsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ImportSourceCredentialsCommandOutput>;
export declare const deserializeAws_json1_1InvalidateProjectCacheCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<InvalidateProjectCacheCommandOutput>;
export declare const deserializeAws_json1_1ListBuildBatchesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListBuildBatchesCommandOutput>;
export declare const deserializeAws_json1_1ListBuildBatchesForProjectCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListBuildBatchesForProjectCommandOutput>;
export declare const deserializeAws_json1_1ListBuildsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListBuildsCommandOutput>;
export declare const deserializeAws_json1_1ListBuildsForProjectCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListBuildsForProjectCommandOutput>;
export declare const deserializeAws_json1_1ListCuratedEnvironmentImagesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListCuratedEnvironmentImagesCommandOutput>;
export declare const deserializeAws_json1_1ListProjectsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListProjectsCommandOutput>;
export declare const deserializeAws_json1_1ListReportGroupsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListReportGroupsCommandOutput>;
export declare const deserializeAws_json1_1ListReportsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListReportsCommandOutput>;
export declare const deserializeAws_json1_1ListReportsForReportGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListReportsForReportGroupCommandOutput>;
export declare const deserializeAws_json1_1ListSharedProjectsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListSharedProjectsCommandOutput>;
export declare const deserializeAws_json1_1ListSharedReportGroupsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListSharedReportGroupsCommandOutput>;
export declare const deserializeAws_json1_1ListSourceCredentialsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListSourceCredentialsCommandOutput>;
export declare const deserializeAws_json1_1PutResourcePolicyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutResourcePolicyCommandOutput>;
export declare const deserializeAws_json1_1RetryBuildCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RetryBuildCommandOutput>;
export declare const deserializeAws_json1_1RetryBuildBatchCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RetryBuildBatchCommandOutput>;
export declare const deserializeAws_json1_1StartBuildCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartBuildCommandOutput>;
export declare const deserializeAws_json1_1StartBuildBatchCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartBuildBatchCommandOutput>;
export declare const deserializeAws_json1_1StopBuildCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StopBuildCommandOutput>;
export declare const deserializeAws_json1_1StopBuildBatchCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StopBuildBatchCommandOutput>;
export declare const deserializeAws_json1_1UpdateProjectCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateProjectCommandOutput>;
export declare const deserializeAws_json1_1UpdateProjectVisibilityCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateProjectVisibilityCommandOutput>;
export declare const deserializeAws_json1_1UpdateReportGroupCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateReportGroupCommandOutput>;
export declare const deserializeAws_json1_1UpdateWebhookCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateWebhookCommandOutput>;
